﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FolderBrowserDialog {
    /// <summary>
    /// Interaction logic for WInsertDirectory.xaml
    /// </summary>
    public partial class WInsertDirectory : Window {

        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String NewDirectory {
            get { return tInput.Text.Trim(); }
        }

        public WInsertDirectory(Window parent) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner      
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tInput.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            String newFile = tInput.Text.Trim();
            if (CheckFilename(newFile)) {
                retcode = true;
                Close();
            }
            else {
                ErrorMsg("Der neue Name ist nicht gültig", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

        public void ErrorMsg(String text, String title) {
            MessageBox.Show(text, title, MessageBoxButton.OK, MessageBoxImage.Error);
        }


        /// <summary>
        /// Prueft den Dateinamen auf fehlerhafte Zeichen
        /// </summary>
        /// <param name="filename"></param>
        /// <returns></returns>
        public bool CheckFilename(String filename) {
            if (filename.Length == 0)
                return false;
            else {
                bool result = true;
                for (int i = 0; i < filename.Length; i++) {
                    String ch = filename.Substring(i, 1);
                    switch (ch) {
                        case "\\": result = false; break;
                        case "/": result = false; break;
                        case ":": result = false; break;
                        case "?": result = false; break;
                        case "*": result = false; break;
                        case "\"": result = false; break;
                        case "<": result = false; break;
                        case ">": result = false; break;
                        case "|": result = false; break;
                    }// case
                }// for
                return result;
            }// if
        }  //  pruefe_dateinamen 

    }
}
