﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Microsoft.Win32;
using System.IO;

namespace FolderBrowserDialog {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        public string C_REG_ADR = "SOFTWARE\\HSHARZ\\FolderBrowserDialog";

        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            String path = ReadRegString(C_REG_ADR, "path1");
            if (Directory.Exists(path)) {
                tPath1.Text = path;
            }
            path = ReadRegString(C_REG_ADR, "path2");
            if (Directory.Exists(path)) {
                tPath2.Text = path;
            }
        }  // Window_Loaded


        private void bnSelectPath1_Click(object sender, RoutedEventArgs e) {
            WSelectDirectory dialog = new WSelectDirectory(this, tPath1.Text);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                tPath1.Text = dialog.SelectDirectory;
                WriteRegString(C_REG_ADR, "path1", dialog.SelectDirectory);
            }

        }

        private void bnSelectPath2_Click(object sender, RoutedEventArgs e) {
            WSelectDirectory dialog = new WSelectDirectory(this, tPath2.Text);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                tPath2.Text = dialog.SelectDirectory;
                WriteRegString(C_REG_ADR, "path2", dialog.SelectDirectory);
            }
        }


        public String ReadRegString(string root, string KeyName) {
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return "";
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        sKey = "";
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                    }
                    return sKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry " + KeyName.ToUpper());
                return "";
            }
        }  // readRegString


        public static bool WriteRegString(string root, string KeyName, string Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry string" + KeyName.ToUpper());
                return false;
            }
        }


    }
}
